<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../paper-button/paper-button.html">

<dom-module id="dez-label-bar-buttons">
  <template>
    <style>
    </style>
    <template is="dom-repeat" items="[[_buttonsInfos]]" mutable-data>
      <paper-button
        noink no-animations raised
        style="
          text-transform: inherit;
          background-color:rgba([[item.color.rgb]],[[item.opacity]]);
        "
        on-tap="_addLabel">
        [[item.name]]
      </paper-button>
    </template>
  </template>

  <script>
    class DezLabelBarButtons extends Polymer.Element {

      static get is() { return 'dez-label-bar-buttons'; }

      /**
      * Fired when a button is taped.
      *
      * @event button-taped
      */

      static get properties() {
        return {
          buttonsData: {
            type: Array,
            observer: "_buttonsDataChanged"
          },
          selectedName: {
            type: String,
            observer: "_selectedNameChanged",
            notify: true
          }
        };
      }

      _selectedNameChanged () {
        if (this._notInNames(this.selectedName)) {
          this._unselectButtons()
        } else {
          if (!this._isSelected(this.selectedName)) {
            this._select(this.selectedName)
          }
        }
      }

      _setDefaultTypeToFirst () {
        let firstBtnData = this._buttonsInfos[0]
        this._select(firstBtnData.name)
      }

      _notInNames(name) {
        return this._buttonsInfos.filter(infos => infos.name == name).length == 0
      }

      _unselectButtons () {
        this._buttonsInfos = this._buttonsInfos.map(infos => {
          infos.state = ""
          infos.opacity = "0.2"
          return infos
        })
      }

      _isSelected (name) {
        return this._buttonsInfos
        .filter(infos => infos.name == name && infos.state == "selected")
        .length == 1
      }

      _select(name) {
        this._buttonsInfos = this._buttonsInfos.map(infos => {
          if (infos.name == name) {
            infos.state = "selected"
            infos.opacity = "0.6"
          } else {
            infos.state = ""
            infos.opacity = "0.2"
          }
          return infos
        })
        this.selectedName = name
      }

      _addLabel (event) {
        let name = event.model.item.name
        this.selectedName = name
        this.dispatchEvent(new CustomEvent('button-taped'))
        this._buttonsInfos = this._buttonsInfos.map(infos => {
          infos.state = infos.name==name?"selected":""
          infos.opacity = infos.name==name?"0.6":"0.2"
          return infos
        })
      }

      _buttonsDataChanged () {
        this._buttonsInfos = this.buttonsData.map(data => {
          return {
            name: data.name,
            color: data.color,
            state: "",
            opacity: "0.2"
          }
        })
        this._setDefaultTypeToFirst ()
      }

    }

    window.customElements.define(DezLabelBarButtons.is, DezLabelBarButtons);
  </script>
</dom-module>
